%C:\Users\Kristine\Dropbox\Working_directory2\Haust 2015\Integrated dynamic analysis of wind turbines\Results\fatigue-peng\IEA_ws8_NTM_1


%perform spectral analysis
clc
close all
clear all
%%%------------------------------------------------------------------------
Hs=153;     % m
Tp=155;     % s
sd=131; 
%%%------------------------------------------------------------------------
%read in the results
%[PlatMotions ,time_SIMO, time_RIFLEX, TowerBaseBMY, TowerBaseBMZ, ML2] =readTimeDomainResults(Hs,Tp,sd);
[PlatMotions ,time_SIMO, time_RIFLEX, TowerBaseBMY, TowerBaseBMZ, ML2] =readTimeDomainResults(Hs,Tp,sd);
%PlatMotions = m m m deg deg deg 

% filename = 'OECW4_SFC.xlsx';
% sheet='103';
% 
initwafo('full',1,1);
L=[1000];
g=[]; %Gaussian process
plotflag=1; %plots the spectrum
p=0; %confidence level
method='psd'; %smoothing method NB. sensitive
dflag='mean';%'ma'; % specifies a detrending performed on the signal before estimation 
ftype='w'; %frequency type 
% 
% 
% 
for i = 1:6
 %i=6; 
 

    x=[time_SIMO PlatMotions(:,i)]; 
     
    if i ==1
        S1=dat2spec(x,L,g,plotflag,p);%,method,dflag,ftype);
        
        
    elseif i==2
        S2=dat2spec(x,L,g,plotflag,p);%,method,dflag,ftype);
        

    elseif i==3
        S3=dat2spec(x,L,g,plotflag,p);%,method,dflag,ftype);
        

    elseif i==4
        S4=dat2spec(x,L,g,plotflag,p);%,method,dflag,ftype);
       

    elseif i==5
        S5=dat2spec(x,L,g,plotflag,p);%,method,dflag,ftype);
        
    elseif i==6
        S6=dat2spec(x,L,g,plotflag,p);%,method,dflag,ftype);
        
    end
    
end
 
% % figure(1)
% % plotspec(S1)
% % xlabel('Frequency [rad/s]');
% % xlim([0 5]);
% 
t_start = 500;
% indS = sum(time_SIMO<=t_start);
% offset_motion=mean(PlatMotions(indS:end,:));
% std_motion=sqrt(var(PlatMotions(indS:end,:)));
% max_motion=max(PlatMotions(indS:end,:));
% PlatMotions=PlatMotions(indS:end,:);
% % wave_cut=wave(indS:end,:);
% time_SIMO=time_SIMO(indS:end);

n = 1;
for i = 1:length(time_RIFLEX)
    if time_RIFLEX(i) > t_start
        t_riflex(n) = time_RIFLEX(i);
        ML2_dummy(n)=ML2(i);
        BMY_dummy(n)=TowerBaseBMY(i);
        BMZ_dummy(n)=TowerBaseBMZ(i);
        n = n + 1;
    end
end



time_RIFLEX=t_riflex;
time_RIFLEX_cut=time_RIFLEX';
ML2_cut=ML2_dummy';
BMY_cut=BMY_dummy';
BMZ_cut=BMZ_dummy';



% xlswrite(filename,std_motion',sheet,'B2:B7');
% xlswrite(filename,max_motion',sheet,'B9:B14');
% xlswrite(filename,offset_motion',sheet,'B16:B21');
% warning('off','MATLAB:xlswrite:AddSheet')


offset_ML2=mean(ML2_cut);
std_ML2=sqrt(var(ML2_cut));
max_ML2=max(ML2_cut);
offset_MY=mean(BMY_cut);
std_MY=sqrt(var( BMY_cut));
max_MY=max(BMY_cut);
offset_MZ=mean( BMZ_cut);
std_MZ=sqrt(var(BMZ_cut));
max_MZ=max( BMZ_cut);

% xlswrite(filename,std_ML2,sheet,'L7');
% xlswrite(filename,max_ML2,sheet,'L8');
% xlswrite(filename,offset_ML2,sheet,'L9');
% warning('off','MATLAB:xlswrite:AddSheet')
% % 
% % 
% xlswrite(filename,std_MY,sheet,'L11');
% xlswrite(filename,max_MY,sheet,'L12');
% xlswrite(filename,offset_MY,sheet,'L13');
% warning('off','MATLAB:xlswrite:AddSheet')
% 
% 
% xlswrite(filename,std_MZ,sheet,'L15');
% xlswrite(filename,max_MZ,sheet,'L16');
% xlswrite(filename,offset_MZ,sheet,'L17');
% warning('off','MATLAB:xlswrite:AddSheet')
% 


figure(1)
plotspec(S1)
xlabel('Frequency [rad/s]');
ylabel('Spectral energy [m^{2}-sec/rad]');
title('Motion Spectrum Surge');  
xlim([0 1.2]);

% % figure(2)
% % plotspec(S2)
% % xlabel('Frequency [rad/s]');
% % ylabel('Spectral energy [m^{2}-sec/rad]');
% % title('Motion Spectrum Sway');  
% % xlim([0 2]);
% % 
% figure(3)
% plotspec(S3)
% xlabel('Frequency [rad/s]');
% ylabel('Spectral energy [m^{2}-sec/rad]');
% title('Motion Spectrum Heave');
% xlim([0 1.2]);
% 
% % figure(4)
% % plotspec(S4)
% % xlabel('Frequency [rad/s]');
% % ylabel('Spectral energy [deg^{2}-sec/rad]');
% % title('Motion Spectrum Roll');
% % xlim([0 2.0]);
% 
% figure(5)
% plotspec(S5)
% xlabel('Frequency [rad/s]');
% ylabel('Spectral energy [deg^{2}-sec/rad]');
% title('Motion Spectrum Pitch');
% xlim([0 1.2]);

% figure(6)
% plotspec(S6)
% xlabel('Frequency [rad/s]');
% ylabel('Spectral energy [deg^{2}-sec/rad]');
% title('Motion Spectrum Yaw');
% xlim([0 1.5]);

x2=[time_RIFLEX_cut BMY_cut];
S7=dat2spec(x2,L,g,plotflag,p);%,g,plotflag,p);%,method,dflag,ftype);

figure(7)
plotspec(S7)
xlabel('Frequency [rad/s]');
ylabel('Spectral energy [(KNm)^{2}-sec/rad]');
title('Fore-aft bending moment spectrum (My)');
xlim([0 4]);
%ylim([0 1E+07]);
% 
% 
x3=[time_RIFLEX_cut BMZ_cut ];
S8=dat2spec(x3,L,g,plotflag,p);

figure(8)
plotspec(S8)
xlabel('Frequency [rad/s]');
ylabel('Spectral energy [(KNm)^{2}-sec/rad]');
title('Side-side bending moment spectrum (Mz)');
xlim([0 5]);
% % 
x4=[time_RIFLEX_cut ML2_cut];
S9=dat2spec(x4,L,g,plotflag,p);

figure(9)
plotspec(S9)
xlabel('Frequency [rad/s]');
ylabel('Spectral energy [(KN)^{2}-sec/rad]');
title('ML2 spectrum');
xlim([0 2]);

% x5=[time_SIMO wave_cut];
% S10=dat2spec(x5,L,g,plotflag,p);
% 
% figure(10)
% plotspec(S10)
% xlabel('Frequency [rad/s]');
% ylabel('Spectral energy [(KN)^{2}-sec/rad]');
% title('Wave spectrum');
% xlim([0 2]);